VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form FrmCls 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Resource Creator"
   ClientHeight    =   4695
   ClientLeft      =   5775
   ClientTop       =   3465
   ClientWidth     =   4530
   Icon            =   "FrmCls.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4695
   ScaleWidth      =   4530
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton bttHelp 
      Caption         =   "?"
      Height          =   375
      Left            =   4080
      TabIndex        =   16
      Top             =   120
      Width           =   375
   End
   Begin MSComDlg.CommonDialog CDlg 
      Left            =   2040
      Top             =   3720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Open"
   End
   Begin VB.CommandButton bttChange 
      Caption         =   "Change"
      Height          =   375
      Left            =   3360
      TabIndex        =   13
      Top             =   1680
      Width           =   1095
   End
   Begin VB.ComboBox cmbType 
      Height          =   315
      Left            =   1920
      Style           =   2  'Dropdown-Liste
      TabIndex        =   12
      Top             =   2880
      Width           =   2535
   End
   Begin VB.CommandButton bttFile 
      Caption         =   "..."
      Height          =   285
      Left            =   4080
      TabIndex        =   10
      Top             =   2520
      Width           =   375
   End
   Begin VB.TextBox txtFile 
      Height          =   285
      Left            =   1920
      TabIndex        =   9
      Top             =   2520
      Width           =   2175
   End
   Begin VB.TextBox txtID 
      Height          =   285
      Left            =   1920
      MaxLength       =   15
      TabIndex        =   7
      Top             =   2160
      Width           =   2535
   End
   Begin VB.CommandButton bttDelete 
      Caption         =   "Remove"
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton bttAdd 
      Caption         =   "Add"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton bttCompile 
      Caption         =   "Compile Resources"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   4200
      Width           =   1575
   End
   Begin VB.CommandButton bttSaveToC 
      Caption         =   "Save ToC"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   4200
      Width           =   1335
   End
   Begin VB.ListBox Res 
      Height          =   2010
      Left            =   120
      TabIndex        =   0
      Top             =   45
      Width           =   3135
   End
   Begin VB.Label lblResSize 
      Caption         =   "0"
      Height          =   255
      Left            =   1920
      TabIndex        =   15
      Top             =   3240
      Width           =   2535
   End
   Begin VB.Label lblSize 
      Caption         =   "Size in bytes:"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   3240
      Width           =   1575
   End
   Begin VB.Label lblType 
      Caption         =   "Resource Type:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2880
      Width           =   1575
   End
   Begin VB.Label lblFile 
      Caption         =   "Source File:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   2520
      Width           =   1575
   End
   Begin VB.Label lblID 
      Caption         =   "Resource ID (Key):"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2160
      Width           =   1575
   End
   Begin VB.Label lblCount 
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3360
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
End
Attribute VB_Name = "FrmCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor: Konnrad Rudolph, Mad Rat Pro.

Option Explicit

' add resource to list
Private Sub bttAdd_Click()
    Dim Success As String, Item As Integer
    
    If txtID <> "" And Dir$(txtFile) <> "" And txtFile <> "" Then
        Success = uResources.Add(txtFile, txtID, cmbType.ListIndex)
        If Success <> txtID Then
            MsgBox "An error occurred! Please check the source file", _
              vbExclamation, "Error"
            Exit Sub
        End If
        Res.Clear
        For Item = 1 To uResources.Count
            Res.AddItem uResources.ID(Item)
        Next
    Else
        MsgBox "Please fill in all fields correctly!", _
          vbExclamation, "Error"
    End If
    lblCount = uResources.Count
End Sub

'chages data of a resource according to the inputs
Private Sub bttChange_Click()
    Dim SelRes As String, ResPath As String, ResType As Integer
    
    If Dir$(txtFile) <> "" And txtFile <> "" Then
        ResPath = txtFile
        ResType = cmbType.ListIndex
        SelRes = Res.List(Res.ListIndex)
        If SelRes = "" Then Exit Sub
        With uResources
            .Path(SelRes) = ResPath
            .rcType(SelRes) = ResType
            lblResSize = .Size(SelRes)
            txtID = SelRes
        End With
    End If
End Sub

Private Sub bttCompile_Click()
    With CDlg
        .DialogTitle = "Compile Resource Script"
        .Filter = "Compiled Resource Scripts|*.res"
        .FileName = ""
        On Error GoTo ErrorbttCompile
        .CancelError = True
        .ShowSave
        If .FileName = "" Then Exit Sub
        If uResources.Compile(.FileName) = 0 Then
            MsgBox "Error while compiling. Please check resource files!", _
              vbExclamation, "Error"
        Else
            MsgBox "Script compiled successful!", vbInformation, "Compiled"
        End If
    End With
    Exit Sub
    
ErrorbttCompile:
End Sub

' removes selected element from list
Private Sub bttDelete_Click()
    Dim SelRes As String, I As Integer
    
    SelRes = Res.List(Res.ListIndex)
    If SelRes = "" Then Exit Sub
    If MsgBox("Do you really want to remove " & _
      SelRes & " from the list?", vbQuestion Or vbYesNo, _
      "Remove") = vbNo Then Exit Sub
    If Not uResources.Remove(SelRes) Then
        MsgBox "Element could not be removed", vbCritical _
        , "Error"
    Else
        txtID = ""
        txtFile = ""
        cmbType.ListIndex = 0
        lblResSize = "0"
        Res.Clear
        For I = 1 To uResources.Count
            Res.AddItem uResources.ID(I)
        Next
        lblCount = uResources.Count
    End If
End Sub

' user chooses path for resource file
Private Sub bttFile_Click()
    With CDlg
        .DialogTitle = "Select Source"
        .Filter = "All Files|*.*|Bitmaps|*.bmp|Sound Buffer|*.wav|Text Data|*.txt" _
          & "|Data Files|*.dat|Binary Files|*.bin"
        On Error GoTo ErrorFile
        .CancelError = True
        .ShowOpen
        If .FileTitle = "" Then Exit Sub
        Select Case LCase$(Right$(.FileTitle, 3))
        Case "bmp"
            cmbType.ListIndex = 0
        Case "wav"
            cmbType.ListIndex = 1
        Case "txt", "dat"
            cmbType.ListIndex = 2
        Case Else
            cmbType.ListIndex = 3
        End Select
        txtFile = .FileName
    End With
    Exit Sub
    
ErrorFile:
End Sub

Private Sub bttHelp_Click()
    DlgInfo.Show vbModal
End Sub

' load resource script
Private Sub bttLoadToC_Click()
    ' sorry, too lazy
    MsgBox "Sorry, not implemented... do it yourself if you please", vbInformation, "Sorry"
    
ErrorLoadToC:
End Sub

' saves data to resource script
Private Sub bttSaveToC_Click()
    With CDlg
        .DialogTitle = "Save as Resource Script"
        .Filter = "Resource Scripts|*.rc"
        .FileName = ""
        On Error GoTo ErrorSaveToC
        .CancelError = True
        .ShowSave
        If .FileName = "" Then Exit Sub
        uResources.WriteToC .FileName
    End With
    Exit Sub

ErrorSaveToC:
End Sub

Private Sub Form_Load()
    ' initialize combo box
    With cmbType
        .AddItem "0 - Bitmap"
        .AddItem "1 - Sound Buffer"
        .AddItem "2 - Data Table"
        .AddItem "3 - Binary File"
        .AddItem "4 - Data Chain"
        .ListIndex = 0
    End With
    txtFile.Text = ""
End Sub

' loads resource data into fields
Private Sub Res_Click()
    txtID = Res.List(Res.ListIndex)
    txtFile = uResources.Path(txtID)
    cmbType.ListIndex = uResources.rcType(txtID)
    lblResSize = uResources.Size(txtID)
End Sub
