Attribute VB_Name = "defBitmap"
Option Explicit

' definition file for Bitmap loading and blitting!

' API to blit bitmap data to DC
Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, _
  ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, _
  ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, _
  lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

' const needed for StretchDIBits
Global Const SRCCOPY = &HCC0020

' header of BMP file (= 13 bytes)
Public Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type

' info header of BMP file (= 40 bytes)
Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

' RGB value with Alpha value for 24/32 bit per pixel
' (= 4 bytes)
Public Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

' BMP info for blitting (= 44 bytes)
Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To 255) As RGBQUAD
End Type
